/* Distributed under the terms of GPLv3 or later. See COPYING for details. */

#include <complex.h>

typedef __complex__ double dcomplex;

#ifndef INCLUDE_LAPACK_CALLS_H_
#include "lapacke.h"
#include "../include/lapack_calls.h"
#endif

#ifdef USE_LAPACK
void zinvert(dcomplex **mat, lapack_int n, int &jer) {
  jer = 0;
  __complex__ double *arr = new dcomplex[n * n];
  const dcomplex uim = 0.0 + 1.0 * I;
  for (lapack_int i = 0; i < n; i++) {
    for (lapack_int j = 0; j < n; j++) {
      lapack_int idx = i + n * j;
      arr[idx] = mat[j][i];
    }
  }
  
  lapack_int* IPIV = new lapack_int[n]();
  
  if (!LAPACKE_zgetrf(LAPACK_ROW_MAJOR, n, n, arr, n, IPIV)) jer = 1;
  if (!LAPACKE_zgetri(LAPACK_ROW_MAJOR, n, arr, n, IPIV)) jer = 2;
  for (lapack_int i = 0; i < n; i++) {
    for (lapack_int j = 0; j < n; j++) {
      lapack_int idx = i + n * j;
      mat[j][i] = arr[idx];
    }
  }
  delete[] IPIV;
  delete[] arr;
}
#endif
